/*
 * RedundantStateRemover.h
 *
 *  Created on: 4. 3. 2014
 *      Author: tomas
 */

#ifndef REDUNDANTSTATEREMOVER_H_
#define REDUNDANTSTATEREMOVER_H_

#include <deque>
#include <set>

#include <automaton/FSM/FSM.h>

namespace trim
{

#define isInSet(x,set) ( (set).find((x)) != (set).end())

/**
 * Melichar 2.32
 */
class RedundantStateRemover
{
public:
    static automaton::FSM remove( const automaton::FSM & fsm );
};

} /* namespace trim */

#endif /* REDUNDANTSTATEREMOVER_H_ */
