/*
 * UnreachableStateRemover.h
 *
 *  Created on: 18. 1. 2014
 *      Author: tomas
 */

#ifndef UNREACHABLE_H_
#define UNREACHABLE_H_

#include <automaton/FSM/FSM.h>
#include <AlibException.h>

#include <algorithm>
#include <iterator>
#include <map>
#include <set>

namespace trim
{

#define isInSet(x,set) ( (set).find((x)) != (set).end())

/**
 * Melichar 2.29
 */
class UnreachableStateRemover
{
public:
    static automaton::FSM remove( const automaton::FSM & fsm );

private:
    static std::set<automaton::State> findReachableStates( const automaton::FSM & fsm );
};

} /* namespace trim */

#endif /* UNREACHABLE_H_ */
