#ifndef __ABSTRACTFATORRGCONVERTER_H__
#define __ABSTRACTFATORRGCONVERTER_H__

#include <automaton/FSM/FSM.h>
#include <grammar/Regular/RightRegularGrammar.h>
#include <AlibException.h>

#include "../../include/macros.h"
#include "../AbstractFAtoRGConverter.h"

namespace conversions
{

class AbstractFAtoRRGConverter : public AbstractFAtoRGConverter
{
public:
    virtual grammar::RightRegularGrammar convert( ) = 0;
    virtual ~AbstractFAtoRRGConverter( void );

protected:
    grammar::RightRegularGrammar m_grammar;

    AbstractFAtoRRGConverter( const automaton::FSM & automaton );
};

} /* namespace conversions */

#endif /* __ABSTRACTFATORRGCONVERTER_H__ */
