#ifndef __FATORRGCONVERTER_H__
#define __FATORRGCONVERTER_H__

#include <grammar/Regular/RightRegularGrammar.h>
#include <automaton/FSM/FSM.h>

#include "AbstractFAtoRRGConverter.h"

namespace conversions
{

class FAtoRRGConverter : public AbstractFAtoRRGConverter
{
public:
    FAtoRRGConverter( const automaton::FSM & automaton );
    ~FAtoRRGConverter( void );
    grammar::RightRegularGrammar convert ( void );

protected:
    grammar::RightRegularGrammar m_grammar;
};

} /* namespace conversions */

#endif /* __FATORRGCONVERTER_H__ */
