#ifndef __LRGTOFACONVERTER_H__
#define __LRGTOFACONVERTER_H__

#include <automaton/FSM/FSM.h>
#include <grammar/Regular/LeftRegularGrammar.h>

#include "AbstractRGtoFAConverter.h"

namespace conversions
{

class LRGtoFAConverter : public AbstractRGtoFAConverter
{
public:
    LRGtoFAConverter( const grammar::LeftRegularGrammar & grammar );
    ~LRGtoFAConverter( void );
    automaton::FSM convert( void );
};

} /* namespace conversions */

#endif /* __LRGTOFACONVERTER_H__ */
