/*
 * RegExpEpsilon.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: honza
 */

#include "RegExpEpsilon.h"

namespace regexp {

RegExpEpsilon::RegExpEpsilon() {
}

RegExpElement* RegExpEpsilon::clone() const {
	return new RegExpEpsilon();
}

bool RegExpEpsilon::operator<(const RegExpElement& other) const {
	return other > *this;
}

bool RegExpEpsilon::operator==(const RegExpElement& other) const {
	return other == *this;
}

bool RegExpEpsilon::operator>(const RegExpElement& other) const {
	return other < *this;
}


bool RegExpEpsilon::operator<(const Alternation&) const {
	  return true;
}

bool RegExpEpsilon::operator<(const Concatenation&) const {
	  return true;
}

bool RegExpEpsilon::operator<(const Iteration&) const {
	  return true;
}

bool RegExpEpsilon::operator<(const RegExpSymbol&) const {
	  return true;
}

bool RegExpEpsilon::operator==(const RegExpEpsilon&) const {
	  return true;
}

bool RegExpEpsilon::containsEmptyString() const {
	return true;
}

} /* namespace regexp */

